<?php

if (!defined('DIR_CORE')) {
    header('Location: static_pages/');
}

$languages = $this->model_localisation_language->getLanguages();
$this->load->model('setting/setting');

$datatosend = [];
$email = $this->config->get('store_main_email');
$datatosend['email'] = (string) $email;
$datatosend['name'] = (string) $this->config->get('config_owner');
$datatosend['partnerKey'] = '5nl0sikui5';
$pass = get_rand_letters(1) . '12' . strtoupper(get_rand_letters(4));
$datatosend['password'] = $pass;
$datatosend['lang'] = 'en';

$content = http_build_query($datatosend);
if (ini_get('allow_url_fopen')) {
    $useCurl = false;
} elseif (!extension_loaded('curl')) {
    if (!dl('curl.so')) {
        $useCurl = false;
    } else {
        $useCurl = true;
    }
} else {
    $useCurl = true;
}

try {
    $path = 'https://www.smartsupp.com/account/create';
    if (!extension_loaded('openssl')) {
        $path = str_replace('https:', 'http:', $path);
    }
    // $useCurl = true; force curl
    if ($useCurl) {
        $this->log->write('jivochat curl_init');
        if ($curl = curl_init()) {
            $this->log->write('jivochat curl_inside');
            curl_setopt($curl, CURLOPT_URL, $path);
            curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($curl, CURLOPT_POST, true);
            curl_setopt($curl, CURLOPT_POSTFIELDS, $content);
            $response = curl_exec($curl);
            curl_close($curl);
        }
    } else {
        $this->log->write('jivochat file_get_contents');
        $response = file_get_contents(
            $path,
            false,
            stream_context_create(
                [
                    'http' => [
                        'method' => 'POST',
                        'header' => 'Content-Type: application/x-www-form-urlencoded',
                        'content' => $content,
                    ],
                    'ssl' => [
                        'verify_peer' => false,
                        'verify_peer_name' => false,
                    ],
                ]
            )
        );
    }

    if ($response) {
	$this->log->write(print_r($response, true) . ' jivochat install full responce');
        if (strstr($response, 'error')) {
            // {"error":"EmailExists","message":"Email already exists","hint":"email"}
            $response = json_decode($response, true);
            if (is_array($response) && array_key_exists('error', $response) && $response['error'] == 'EmailExists') {
                // client already registered with store email
                $settings['allinoneaccessibility_email'] = $datatosend['email'];
            }
        } else {
            $response = json_decode($response, true);
            if (is_array($response) && array_key_exists('account', $response)) {
                $settings['allinoneaccessibility_codetoken'] = $response['account']['key'];
                foreach ($languages as $lang) {
                    $this->db->query('DELETE FROM ' . $this->db->table('language_definitions') . " WHERE language_id='" . (int) $lang['language_id'] . "' AND section = '1' AND block = 'allinoneaccessibility_allinoneaccessibility' AND language_key = 'allinoneaccessibility_note'");
                    $text = 'SmartsuppChat KEY received. The installation is completed!<br />
                    You will receive a welcome email to ' . $this->db->escape($email) . '. Your smartsupp chat account password is: ' . $this->db->escape($pass) . ' It is higly recommended to change it in your <a href="https://www.smartsupp.com/?affil=332690" target="_blank">smartsupp profile settings</a>.<br />
                    Please Enable this extension!<br />
                    To start answer to your customers just download one of the chat apps<br />
                    <a target="_blank" href="https://itunes.apple.com/us/app/smartsupp/id1258723897?mt=8" class="fa fa-mobile fa-lg" id="appLinkIOS"> iOS</a>
                    <a target="_blank" href="https://play.google.com/store/apps/details?id=cz.dactylgroup.smartsupp.android" class="fa fa-android fa-lg" id="appLinkAndroid"> Android</a>';
                    $this->db->query('INSERT INTO ' . $this->db->table('language_definitions') . " (language_id, section, block,language_key,language_value,date_added)  VALUES ('" . (int) $lang['language_id'] . "', '1', 'allinoneaccessibility_allinoneaccessibility', 'allinoneaccessibility_note', '" . $this->db->escape($text) . "', NOW() );");
                }
            }
            $settings['allinoneaccessibility_email'] = $datatosend['email'];
            // $settings['allinoneaccessibility_password'] = $response['user']['password']; //$datatosend['userPassword']

            return true;
        }
    } else {
    }
} catch (Exception $e) {
    $this->log->write(print_r($e, true) . ' jivochat install connection error');
}

function assign_rand_value($num)
{
    // accepts 1 - 36
    switch ($num) {
        case '1': $rand_value = 'a';
            break;
        case '2': $rand_value = 'b';
            break;
        case '3': $rand_value = 'c';
            break;
        case '4': $rand_value = 'd';
            break;
        case '5': $rand_value = 'e';
            break;
        case '6': $rand_value = 'f';
            break;
        case '7': $rand_value = 'g';
            break;
        case '8': $rand_value = 'h';
            break;
        case '9': $rand_value = 'i';
            break;
        case '10': $rand_value = 'j';
            break;
        case '11': $rand_value = 'k';
            break;
        case '12': $rand_value = 'l';
            break;
        case '13': $rand_value = 'm';
            break;
        case '14': $rand_value = 'n';
            break;
        case '15': $rand_value = 'o';
            break;
        case '16': $rand_value = 'p';
            break;
        case '17': $rand_value = 'q';
            break;
        case '18': $rand_value = 'r';
            break;
        case '19': $rand_value = 's';
            break;
        case '20': $rand_value = 't';
            break;
        case '21': $rand_value = 'u';
            break;
        case '22': $rand_value = 'v';
            break;
        case '23': $rand_value = 'w';
            break;
        case '24': $rand_value = 'x';
            break;
        case '25': $rand_value = 'y';
            break;
        case '26': $rand_value = 'z';
            break;
        case '27': $rand_value = '0';
            break;
        case '28': $rand_value = '1';
            break;
        case '29': $rand_value = '2';
            break;
        case '30': $rand_value = '3';
            break;
        case '31': $rand_value = '4';
            break;
        case '32': $rand_value = '5';
            break;
        case '33': $rand_value = '6';
            break;
        case '34': $rand_value = '7';
            break;
        case '35': $rand_value = '8';
            break;
        case '36': $rand_value = '9';
            break;
    }

    return $rand_value;
}

function get_rand_letters($length)
{
    if ($length > 0) {
        $rand_id = '';
        for ($i = 1; $i <= $length; ++$i) {
            mt_srand((float) microtime() * 1000000);
            $num = mt_rand(1, 26);
            $rand_id .= assign_rand_value($num);
        }
    }

    return $rand_id;
}

$this->cache->delete('*');
